freeslot("SPR_POSS")

-- I wonder what this is for?
-- I kid, I kid, this is obviously for SRB2Persona!
 
-- Hey, you bothered checking the files. If this is included in an unrelated character release, surely this means something... right?
-- PS: SRB2P custom character support works, but is rough.
-- There are NO failsafes if you fuck up declarations, so read the comments here.
 
if not srb2p return end

//personajumpthok
local function personajumpthok(p)
	if p.mo.skin == "sonki"
	and not (p.pflags & PF_THOKKED)
	and p.canjumpthokring == true
		P_Thrust(p.mo, p.mo.angle, 20)
		P_SetObjectMomZ(p.mo, 15*FRACUNIT)
		local jumpthokring = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_JUMPTHOKRING)
		jumpthokring.color = p.mo.color
		jumpthokring.angle = p.cmd.angleturn << 16 + R_PointToAngle2(0, 0, p.cmd.forwardmove*FRACUNIT, -p.cmd.sidemove*FRACUNIT) + ANGLE_90
		jumpthokring.scale = p.mo.scale
		jumpthokring.destscale = p.mo.scale
		jumpthokring.tics = 3
		S_StartSound(p.mo, sfx_thok)
		p.canjumpthokring = false
		p.pflags = $|PF_THOKKED
	end
end
addHook("AbilitySpecial", personajumpthok)
-- Due to the exe nature of the mod, this only requires a one-time check.
 
-- Define our base character's stats!
charStats["sonki"] = {
 
        -- GENERAL
 
        name = "Sonki",        -- This is only for bots / enemies
        basehp = 68,            -- base HP for level 1 (Cannot be <= 0)
        basesp = 20,            -- base SP for level 1 (Can be 0, but not < 0!)
        persona = "thespirit",     -- Persona to use
        melee_natk = "sonic_atk1", -- normal melee attack
 
        -- Normal attack attributes
        -- Scales with game difficulty
        atk = 40,   -- power (generally < 50)
        acc = 95,   -- accuracy (%)
        crit = 5,   -- crit rate (%)
 
        -- ANIMS
        -- Anims are built like this:
        -- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, ["SPR2_CONST"]}
        -- (SPR2 must be a string, and is optional. Only for use with SPR_PLAY)
 
        -- Note: As of Beta 1.0.0, not all animations are implemented
        -- (* = unimplemented)
 
        anim_stand =        {SPR_PLAY, A, 8, "SPR2_STND"},                  -- standing
        anim_stand_hurt =   {SPR_PLAY, A, 1, "SPR2_STND"},                  -- standing (low HP) *
        anim_stand_bored =  {SPR_PLAY, A, 8, "SPR2_STND"},                  -- standing (occasionally plays after anim_stand has played several times)
        anim_guard =        {SPR_PLAY, A, 1, "SPR2_GARD"},                  -- guarding
        anim_move =         {SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_WALK"},   -- moving
        anim_run =          {SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_RUN_"},   -- guess what
        anim_atk =          {SPR_PLAY, A, B, C, D, 2, "SPR2_ROLL"},         -- attacking
        anim_aoa_end =      {SPR_PLAY, D, C, B, A, 2, "SPR2_ROLL"},         -- jumping out of all-out attack
        anim_hurt =         {SPR_PLAY, A, 35, "SPR2_DEAD"},                 -- taking damage
        anim_getdown =      {SPR_PLAY, A, 1, "SPR2_CNT1"},                  -- knocked down from weakness / crit *
        anim_downloop =     {SPR_PLAY, A, 1, "SPR2_CNT1"},                  -- is down
        anim_getup =        {SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},         -- gets up from down
        anim_death =        {SPR_PLAY, A, 30, "SPR2_PAIN"},                 -- dies
        anim_revive =       {SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},         -- gets revived
 
        -- anim_special1 through anim_special32 may also be used for various purposes (ie: attack animations)
        anim_special1 =     {SPR_PLAY, A, TICRATE, "SPR2_MLEE"},
        anim_special4 =     {SPR_PLAY, A, TICRATE, "SPR2_GARD"},            -- guard
        anim_sepcial5 =     {SPR_PLAY, A, TICRATE, "SPR2_HWLP"},            -- howling prep
        anim_special6 =     {SPR_PLAY, A, B, 2, "SPR2_HOWL"},               -- howling
 
        -- VOICES
        -- Possible list of voices
        -- vfx_action = {"sfx_voice1", "sfx_voice2", [...], "sfx_voicen"}
 
        -- ...In the case of kanade, she's silent, but I will leave these here for reference!
 
        vfx_summon = {},    -- Summoning Persona to use a Skill
        vfx_skill = {},     -- Used a Skill
        vfx_item = {},      -- Used an item
        vfx_hurt = {},      -- Sustained damage
        vfx_hurtx = {},     -- Sustained heavy damage / Critical hit / Weakness
        vfx_die = {},       -- Death
        vfx_heal = {},      -- Healed by teammate
        vfx_healself = {},  -- Healed self
        vfx_kill = {},      -- Killed an enemy
        vfx_1more = {},     -- Performed 1more
        vfx_crit = {},      -- Cut-in for Weakness/Critical Hit
        vfx_aoaask = {},    -- Ask to All-Out Attack
        vfx_aoado = {},     -- Performing All-Out Attack
        vfx_aoarelent = {}, -- Relenting from All-Out Attack
        vfx_miss = {},      -- Missed attack
        vfx_dodge = {},     -- Dodged enemy attack
        vfx_win = {},       -- Battle won
        vfx_levelup = {},   -- Level Up!
 
 
        -- HUD DEFINTIIONS
 
        icon = "ICO_SONK",          -- head icon for character select
        hudbust = "H_SONKIB",           -- patch to draw on the stat hud
        hudaoa = "H_SONKIA",        -- patch for all out attack hud
        aoa_quote = "*Sonic 1 Sound Effects*",
        hudcutin = "KANA_A",        -- cut in frames prefix
 
        -- Tip to display on the character select.
        -- Give insight on their skill type and their strengths/weaknesses in battle!
        tip = "Specializes in hard hitting Slash skills.\nShe is agile and has a good damage potential,\nhowever she is unable to sustain herself and\nappreciates buffs and healing from\na well rounded party.",
}
 
 
personaList["thespirit"] = {
        -- GENERAL
        name = "Spirit",    -- Name of the Persona
        arcana = nil,           -- Arcana (unused in Beta 1.0.0, can be left nil as well)
 
        sprite = SPR_PSN0,      -- Unused outside of debugging purposes for shortcuts. Can be left nil
        startframe = 0,         -- Unused outside of debugging purposes for shortcuts. Can be left nil
 
        -- Animations function the same way they do for players. (In Kanade's case, she's so good she doesn't need one, so let's make it invisible)
        anim_idle =     {SPR_PISO, D, D, E, E},  -- Idle animation when summoned in the menu
        anim_atk =      {SPR_PISO, A, B, C},  -- Animation when attacking
 
        -- Stats (at level 10)
        -- Remember that stats naturally cap at 99.
        strength = 9,
        magic = 7,
        endurance = 8,
        luck = 15,
        agility = 12,
 
        -- Affinities (weak, resist, block, drain)
        weak = ATK_ELEC,
        resist = ATK_CURSE,
        block = ATK_PIERCE,
		drain = ATK_NUCLEAR,
 
        /*Skills learnt and their level:
            {
                {"skillname", level, ["skill_to_replace"]},
                {"skill2name", level, ["skill_to_replace"]},
                [...]
            }
 
            Documentation for every existing skill name will be available publically at a later date.
            For now, feel free to scout the game files yourself!
 
            the 3rd argument is only useful on higher difficulties where characters automatically start at
            higher levels, meaning their skills need to be automatically replaced.
 
            NOTE: Characters can only have 8 skills total! But if you mess this up, the game won't stop you from having 69 skills.
            So pay attention!
        */
 
        skills = {
                    {"skewer", 1}, {"frei", 1},
                    {"counter", 12}, {"torrent shot", 16},
                    {"flame link", 20}, {"teardrop", 25},
                    {"mafrei", 27}, {"nuke break", 30},
 
                    {"counterstrike", 31, "counter"},
                    {"freila", 38, "frei"},
                    {"danse macabre", 43, "skewer"},
                    {"gigantic fish", 46, "torrent shot"},
                    {"agiverse", 50, "flame link"},
 
                    {"mafreila", 54, "mafrei"},
                    {"freidyne", 56, "freila"},
                    {"agneyastra", 60, "counterstrike"},
                    {"mafreila", 63, "mafrei"},
                    {"mafreidyne", 68, "mafreila"},
 
                    {"kannon", 73, "danse macabre"},
                },
}